2 # some elements originated from qemu configure
5 TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6 TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7 TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8 trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
27 $CC -E -dD $CFLAGS include/arm_features.h | grep -q "$1" || return 1
33 $CC -E -dD $CFLAGS include/arm_features.h | grep "$1" | awk '{print $3}'
37 # setting options to "yes" or "no" will make that choice default,
38 # "" means "autodetect".
40 platform_list="generic pandora maemo caanoo libretro"
42 builtin_gpu_list="peops unai neon"
44 sound_driver_list="oss alsa pulseaudio sdl libretro"
46 plugins="plugins/spunull/spunull.so \
47 plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
64 # these are for known platforms
65 optimize_cortexa8="no"
66 optimize_arm926ej="no"
69 CC="${CC-${CROSS_COMPILE}gcc}"
70 CXX="${CXX-${CROSS_COMPILE}g++}"
71 AS="${AS-${CROSS_COMPILE}as}"
72 AR="${AS-${CROSS_COMPILE}ar}"
73 MAIN_LDLIBS="$LDLIBS -ldl -lm -lpthread"
74 config_mak="config.mak"
82 # call during arg parsing, so that cmd line can override platform defaults
90 sound_drivers="oss alsa"
93 optimize_cortexa8="yes"
100 optimize_cortexa8="yes"
107 optimize_arm926ej="yes"
111 sound_drivers="libretro"
115 fail "unsupported platform: $platform"
121 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
123 --help|-h) show_help="yes"
125 --platform=*) set_platform "$optarg"
127 --gpu=*) builtin_gpu="$optarg"
129 --sound-drivers=*) sound_drivers="$optarg"
131 --enable-neon) have_arm_neon="yes"
133 --disable-neon) have_arm_neon="no"
135 --disable-dynarec) enable_dynarec="no"
137 *) echo "ERROR: unknown option $opt"; show_help="yes"
142 if [ "$show_help" = "yes" ]; then
144 echo " --help print this message"
145 echo " --platform=NAME target platform [$platform]"
146 echo " available: $platform_list"
147 echo " --gpu=NAME builtin gpu plugin [guessed]"
148 echo " available: $builtin_gpu_list"
149 echo " --sound-drivers=LIST sound output drivers [guessed]"
150 echo " available: $sound_driver_list"
151 echo " --enable-neon"
152 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
153 echo " --disable-dynarec disable dynamic recompiler"
154 echo " (dynarec is only available and enabled on ARM)"
155 echo "influential environment variables:"
156 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
160 # validate selections
161 if [ "x$builtin_gpu" != "x" ]; then
162 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
163 fail "unsupported builtin gpu plugin: $builtin_gpu"
167 if [ "x$sound_drivers" != "x" ]; then
168 for d in $sound_drivers; do
169 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
170 fail "unsupported sound driver: $sound_driver"
175 if [ "$need_libpicofe" = "yes" ]; then
176 if ! test -f "frontend/libpicofe/README"; then
177 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
181 if [ "$need_warm" = "yes" ]; then
182 if ! test -f "frontend/warm/README"; then
183 fail "wARM is missing, please run 'git submodule init && git submodule update'"
187 # basic compiler test
190 int main(void) { return 0; }
192 if ! compile_binary; then
193 fail "compiler test failed, please check config.log"
196 if [ -z "$ARCH" ]; then
197 ARCH=`$CC -dumpmachine | awk -F '-' '{print $1}'`
205 if [ "$optimize_cortexa8" = "yes" ]; then
206 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
207 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
209 if [ "$optimize_arm926ej" = "yes" ]; then
210 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
211 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
214 if [ "x$have_arm_neon" = "x" ]; then
215 # detect NEON from user-supplied cflags to enable asm code
216 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
218 if [ "x$have_armv7" = "x" ]; then
219 if check_define HAVE_ARMV7; then
225 if [ "x$have_armv6" = "x" ]; then
226 if check_define HAVE_ARMV6; then
231 if [ "x$have_armv5" = "x" ]; then
232 have_armv5=`check_define HAVE_ARMV5 && echo yes` || true
235 if [ "x$builtin_gpu" = "x" ]; then
236 if [ "$have_arm_neon" = "yes" ]; then
238 elif [ "$have_armv7" != "yes" ]; then
239 # pre-ARMv7 hardware is usually not fast enough for peops
246 # automatically set mfpu and mfloat-abi if they are not set
247 if [ "$have_arm_neon" = "yes" ]; then
249 elif [ "$have_armv6" = "yes" ]; then
252 if [ "x$fpu" != "x" ]; then
253 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu"
254 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu"
255 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
256 if [ "$floatabi_set_by_gcc" != "yes" ]; then
257 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
258 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
262 # must disable thumb as recompiler can't handle it
263 if check_define __thumb__; then
264 CFLAGS="$CFLAGS -marm"
267 # warn about common mistakes
268 if [ "$have_armv5" != "yes" ]; then
269 if ! echo "$CFLAGS" | grep -q -- '-mcpu=\|-march='; then
270 echo "Warning: compiling for ARMv4, is that really what you want?"
271 echo "You probably should specify -mcpu= or -march= like this:"
272 echo " CFLAGS=-march=armv6 ./configure ..."
275 if [ "$have_arm_neon" = "yes" -a "$have_armv7" != "yes" ]; then
276 echo "Warning: compiling for NEON, but not ARMv7?"
277 echo "You probably want to specify -mcpu= or -march= like this:"
278 echo " CFLAGS=-march=armv7-a ./configure ..."
282 # dynarec only available on ARM
287 if [ "x$builtin_gpu" = "x" ]; then
291 # supposedly we can avoid -fPIC on armv5 for slightly better performace?
292 if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
293 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
296 if [ "$ram_fixed" = "yes" ]; then
297 CFLAGS="$CFLAGS -DRAM_FIXED"
305 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES"
308 CFLAGS="$CFLAGS -fPIC"
309 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
313 # header/library presence tests
318 int main(void) { uncompress(0, 0, 0, 0); }
327 void main() { png_init_io(0, 0); }
335 #include <sys/soundcard.h>
336 #include <sys/ioctl.h>
337 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
345 #include <alsa/asoundlib.h>
346 void main() { snd_pcm_open(0, 0, 0, 0); }
354 #include <pulse/pulseaudio.h>
355 void main() { pa_threaded_mainloop_new(); }
364 void main() { SDL_OpenAudio(0, 0); }
372 #include <X11/Xlib.h>
373 void *f() { return XOpenDisplay(0); }
378 # see if we have c64_tools for TI C64x DSP
382 #include <inc_libc64_mini.h>
383 int f() { return dsp_open(); }
388 MAIN_LDLIBS="$MAIN_LDLIBS -lz"
389 check_zlib || fail "please install zlib (libz-dev)"
391 MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
392 check_libpng || fail "please install libpng (libpng-dev)"
394 # find what audio support we can compile
395 if [ "x$sound_drivers" = "x" ]; then
396 if check_oss; then sound_drivers="$sound_drivers oss"; fi
397 if check_alsa -lasound; then
398 sound_drivers="$sound_drivers alsa"
399 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
401 if check_pulseaudio -lpulse; then
402 sound_drivers="$sound_drivers pulseaudio"
403 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
405 if [ "$need_sdl" = "yes" ] || check_sdl `sdl-config --cflags --libs`; then
406 sound_drivers="$sound_drivers sdl"
410 if echo $sound_drivers | grep -q "\<oss\>"; then
411 check_oss || fail "oss support is missing"
413 if echo $sound_drivers | grep -q "\<alsa\>"; then
414 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
415 check_alsa || fail "please install libasound2-dev"
417 if echo $sound_drivers | grep -q "\<pulseaudio\>"; then
418 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
419 check_pulseaudio || fail "pulseaudio support is missing"
423 if [ "$need_sdl" = "yes" ]; then
424 which sdl-config > /dev/null || \
425 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
426 CFLAGS="$CFLAGS `sdl-config --cflags`"
427 MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS"
428 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
431 # check for tslib (only headers needed)
432 if [ "x$have_tslib" = "x" ]; then
435 void test(struct ts_sample sample) {}
437 if compile_object; then
444 # check for VideoCore stuff for Raspberry Pi
445 if [ -d /opt/vc/include -a -d /opt/vc/lib -a "$VIDEOCORE" != "no" ]; then
446 CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/interface/vmcs_host/linux"
447 LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib"
448 if [ -f /opt/vc/lib/libbcm_host.so ]; then
449 LDLIBS_GLES="$LDLIBS_GLES -lbcm_host"
455 # check for GLES headers
460 return (int)eglGetDisplay( (EGLNativeDisplayType)0 );
463 if [ "$VIDEOCORE" = "yes" ] && compile_binary $CFLAGS_GLES -lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES; then
465 LDLIBS_GLES="-lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES"
466 elif compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then
468 LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES"
469 elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then
471 LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES"
474 if check_c64_tools; then
478 if [ "$have_gles" = "yes" ]; then
479 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
481 if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
482 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
485 # check for xlib (only headers needed)
486 if [ "x$need_xlib" = "xyes" ]; then
487 check_xlib_headers || fail "please install libx11-dev"
490 sizeof_long=`check_define_val __SIZEOF_LONG__`
491 if [ "x$sizeof_long" = "x4" ]; then
492 CFLAGS="$CFLAGS -D_FILE_OFFSET_BITS=64"
496 void test(void *f, void *d) { fread(d, 1, 1, f); }
498 if compile_object -Wno-unused-result; then
499 CFLAGS="$CFLAGS -Wno-unused-result"
502 # short plugin list for display
503 for p in $plugins; do
505 plugins_short="$p1 $plugins_short"
508 # set things that failed to autodetect to "no"
509 test "x$have_armv6" != "x" || have_armv6="no"
510 test "x$have_armv7" != "x" || have_armv7="no"
511 test "x$have_arm_neon" != "x" || have_arm_neon="no"
512 test "x$have_gles" != "x" || have_gles="no"
513 test "x$have_c64x_dsp" != "x" || have_c64x_dsp="no"
515 echo "architecture $ARCH"
516 echo "platform $platform"
517 echo "built-in GPU $builtin_gpu"
518 echo "sound drivers $sound_drivers"
519 echo "plugins $plugins_short"
520 echo "C compiler $CC"
521 echo "C compiler flags $CFLAGS"
522 echo "libraries $MAIN_LDLIBS"
523 echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
524 echo "enable dynarec $enable_dynarec"
525 if [ "$ARCH" = "arm" ]; then
526 echo "ARMv7 optimizations $have_armv7"
527 echo "enable ARM NEON $have_arm_neon"
528 echo "TI C64x DSP support $have_c64x_dsp"
530 echo "tslib support $have_tslib"
531 if [ "$platform" = "generic" ]; then
532 echo "OpenGL ES output $have_gles"
535 echo "# Automatically generated by configure" > $config_mak
536 printf "# Configured with:" >> $config_mak
537 printf " '%s'" "$0" "$@" >> $config_mak
540 echo "CC = $CC" >> $config_mak
541 echo "CXX = $CXX" >> $config_mak
542 echo "AS = $AS" >> $config_mak
543 echo "CFLAGS += $CFLAGS" >> $config_mak
544 echo "ASFLAGS += $ASFLAGS" >> $config_mak
545 echo "LDFLAGS += $LDFLAGS" >> $config_mak
546 echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
547 echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
548 echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
551 if [ "$platform" = "libretro" ]; then
552 echo "TARGET = libretro.so" >> $config_mak
554 echo "ARCH = $ARCH" >> $config_mak
555 echo "PLATFORM = $platform" >> $config_mak
556 echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
557 echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
558 echo "PLUGINS = $plugins" >> $config_mak
559 if [ "$have_arm_neon" = "yes" ]; then
560 echo "HAVE_NEON = 1" >> $config_mak
562 if [ "$have_tslib" = "yes" ]; then
563 echo "HAVE_TSLIB = 1" >> $config_mak
565 if [ "$have_gles" = "yes" ]; then
566 echo "HAVE_GLES = 1" >> $config_mak
567 echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak
568 echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak
570 if [ "$enable_dynarec" = "yes" ]; then
571 echo "USE_DYNAREC = 1" >> $config_mak
573 if [ "$drc_cache_base" = "yes" ]; then
574 echo "DRC_CACHE_BASE = 1" >> $config_mak
576 if [ "$have_c64x_dsp" = "yes" ]; then
577 echo "HAVE_C64_TOOLS = 1" >> $config_mak
580 # use pandora's skin (for now)
581 test -e skin || ln -s frontend/pandora/skin skin
583 # vim:shiftwidth=2:expandtab